/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.solution;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype.Phenotype;

/**
 * Interface for accessing a single solution of a DSE run. It provides access to the sub solutions
 * found by the DSE.
 * 
 * @author barner
 */
public interface IExplorationSolution<P extends Phenotype> {

	/** Returns the sub solution of this {@link IExplorationSolution}. */
	public <T extends Phenotype> T getSubSolution(Class<T> solutionClass);

	/**
	 * Returns all the classes (= keys) of the sub solution of this {@link IExplorationSolution}.
	 */
	public <T extends Phenotype> Collection<Class<T>> getAllSubSolutionClasses();
}
