/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.convert.constraint;

import static org.fortiss.af3.exploration.alg.util.DSMLUtils.getDirectAllocationExpression;

import org.fortiss.af3.exploration.alg.dse.convert.IConverterModule;
import org.fortiss.af3.exploration.dsl_v2.model.booleanp.allocation.ILocationExpression;
import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.moea.model.constraints.InternalConstraint;

/**
 * Converts an allocation pattern {@link ExplorationConstraint} to an {@link InternalConstraint}.
 * 
 * @author diewald
 */
public class AllocationPatternConverter
		implements IConverterModule<ExplorationConstraint<?>, InternalConstraint<?>> {

	/** {@inheritDoc} */
	@Override
	public InternalConstraint<?> convert(ExplorationConstraint<?> constraint) {
		ILocationExpression locExpression = getDirectAllocationExpression(constraint);
		if(locExpression == null) {
			// No allocation pattern. Exit early.
			return null;
		}
		// FIXME(AD): Here, the conversion code would be placed. To ease the handling of
		// expressions, we will preprocess the expressions such that IAdapters are referenced.
		return null;
	}
}
