/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.convert.constraint;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.convert.ConversionManagerBase;
import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.moea.model.constraints.InternalConstraint;
import org.opt4j.core.problem.Decoder;

/**
 * Converts matching DSML-based {@link ExplorationConstraint}s to {@link InternalConstraint}s that
 * are interpreted more efficiently by the DSE. Those constraints are interpretable by
 * {@link Decoder}s.
 * 
 * @author diewald
 */
public class DSMLToInternalConstraintConverter
		extends ConversionManagerBase<ExplorationConstraint<?>, InternalConstraint<?>> {

	/** Constructor. */
	public DSMLToInternalConstraintConverter(Collection<ExplorationConstraint<?>> constraints) {
		super(constraints);
	}

	/** {@inheritDoc} */
	@Override
	protected void addConverters() {
		converters.add(new AllocationPatternConverter());
	}
}
