/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.convert.dsml;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.convert.ConversionManagerBase;
import org.fortiss.af3.exploration.dsl_v2.model.expression.IExpression;

/**
 * Replaces (parts of) a generic DSML expressions into more efficient representations understood by
 * the DDD-SE.
 * 
 * @author diewald
 */
public class DSMLExpressionConverter extends ConversionManagerBase<IExpression, IExpression> {

	/** Constructor. */
	public DSMLExpressionConverter(Collection<IExpression> inputSet) {
		super(inputSet);
	}

	/** {@inheritDoc} */
	@Override
	protected void addConverters() {
		converters.add(new PropertyToFixedValueLiteralConverter());
	}
}
