/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.graph.display;

/**
 * Wrapped for generic Java objects to be displayed in the graph dialog.
 * 
 * @author diewald
 */
public class ObjectVertex<V> {

	/** The element associated with this vertex wrapper. */
	private V element;

	/** Constructor. */
	ObjectVertex(V currentVertex) {
		element = currentVertex;
	}

	/** {@inheritDoc} */
	@Override
	public String toString() {
		if(element instanceof Class) {
			return ((Class<?>)element).getSimpleName();
		}
		return element.toString();
	}
}
