/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.moea.model.constraints.impl;

import org.eclipse.emf.common.util.Enumerator;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.moea.model.constraints.SafetyIntegrityLevelConstraint;
import org.fortiss.af3.safety.model.SIL;
import org.fortiss.af3.safety.model.annotation.SafetyIntegrityLevel;

/**
 * Static method implementations for {@link SafetyIntegrityLevelConstraint}s.
 * 
 * @author diewald
 */
public class SafetyIntegrityLevelConstraintStaticImpl {

	/** Static implementation of the method {@link SafetyIntegrityLevelConstraint#getLimitation}. */
	public static SIL getLimitation(SafetyIntegrityLevelConstraintImpl constr) {
		Object requester = constr.getReqester();
		if(requester instanceof ITaskAdapter<?>) {
			Enumerator sil = ((ITaskAdapter<?>)requester).getRequiredSafetyIntegrityLevel();
			if(sil instanceof SafetyIntegrityLevel) {
				return (SIL)sil;
			}
		}
		return null;
	}
}
